module models/webapp

sig List[T] {}
sig NonEmptyList[T] extends List[T] {
  elt: T,
  rest: List[T]
}
fun first[T](p: List[T]): T {
  result = p.elt
}
fun last[T](p: List[T]): T {
  (some q: p.*rest| result = q.elt && no q.rest)
}
fun elements[T](p: List[T]): set T {
  result = p.*rest.elt
}
fun follows[T](p: List[T], a, b: T) {
  (some x: p.*rest| x.elt = a && x.rest.elt = b)
}
fun addToList[T](p: List[T], a: T): NonEmptyList[T] {
  (some q: NonEmptyList[T]|
    q.elt = a && q.rest = p && result = q)
}
fun removeFromList[T](p: NonEmptyList[T], a: T): List[T] {
  (some q: p.*rest|
    q.rest.elt = a => q.rest = q.rest.rest && result = p)
}

sig BookID {}
sig ClientID {}
sig Book {
  id: BookID,
  reserved: ClientID
}

sig Cart[T] {
  id: ClientID,
  itemlist: List[T]
}
fun addToCart[T](p: Cart[T], a: T): Cart[T] {
  (some r: NonEmptyList[T]|
     // addToList(p.itemlist, a, r) // works
     r = addToList(p.itemlist, a) // error, while the above works
&& result = p)
}

